# **********************************************************************
#
# Copyright (c) 2003-2010 ZeroC, Inc. All rights reserved.
#
# This copy of Ice is licensed to you under the terms described in the
# ICE_LICENSE file included in this distribution.
#
# **********************************************************************

# Ice version 3.4.1

# <auto-generated>
#
# Generated from file `PermissionsVerifier.ice'
#
# Warning: do not edit this file.
#
# </auto-generated>

import Ice, IcePy, __builtin__
import Glacier2_SSLInfo_ice

# Included module Ice
_M_Ice = Ice.openModule('Ice')

# Included module Glacier2
_M_Glacier2 = Ice.openModule('Glacier2')

# Start of module Glacier2
__name__ = 'Glacier2'

if not _M_Glacier2.__dict__.has_key('PermissionsVerifier'):
    _M_Glacier2.PermissionsVerifier = Ice.createTempClass()
    class PermissionsVerifier(Ice.Object):
        '''The Glacier2 permissions verifier. This is called through the
process of establishing a session.'''
        def __init__(self):
            if __builtin__.type(self) == _M_Glacier2.PermissionsVerifier:
                raise RuntimeError('Glacier2.PermissionsVerifier is an abstract class')

        def ice_ids(self, current=None):
            return ('::Glacier2::PermissionsVerifier', '::Ice::Object')

        def ice_id(self, current=None):
            return '::Glacier2::PermissionsVerifier'

        def ice_staticId():
            return '::Glacier2::PermissionsVerifier'
        ice_staticId = staticmethod(ice_staticId)

        def checkPermissions(self, userId, password, current=None):
            '''Check whether a user has permission to access the router.

Arguments:
    userId The user id for which to check permission.

    password The user's password.

    reason The reason why access was denied.

Returns:
    True if access is granted, or false otherwise.'''
            pass

        def __str__(self):
            return IcePy.stringify(self, _M_Glacier2._t_PermissionsVerifier)

        __repr__ = __str__

    _M_Glacier2.PermissionsVerifierPrx = Ice.createTempClass()
    class PermissionsVerifierPrx(Ice.ObjectPrx):

        '''Check whether a user has permission to access the router.

Arguments:
    userId The user id for which to check permission.

    password The user's password.

    reason The reason why access was denied.

Returns:
    True if access is granted, or false otherwise.'''
        def checkPermissions(self, userId, password, _ctx=None):
            return _M_Glacier2.PermissionsVerifier._op_checkPermissions.invoke(self, ((userId, password), _ctx))

        '''Check whether a user has permission to access the router.

Arguments:
    userId The user id for which to check permission.

    password The user's password.

    reason The reason why access was denied.

Returns:
    True if access is granted, or false otherwise.'''
        def begin_checkPermissions(self, userId, password, _response=None, _ex=None, _sent=None, _ctx=None):
            return _M_Glacier2.PermissionsVerifier._op_checkPermissions.begin(self, ((userId, password), _response, _ex, _sent, _ctx))

        '''Check whether a user has permission to access the router.

Arguments:
    userId The user id for which to check permission.

    password The user's password.

    reason The reason why access was denied.

Returns:
    True if access is granted, or false otherwise.'''
        def end_checkPermissions(self, _r):
            return _M_Glacier2.PermissionsVerifier._op_checkPermissions.end(self, _r)

        '''Check whether a user has permission to access the router.

Arguments:
    userId The user id for which to check permission.

    password The user's password.

    reason The reason why access was denied.

Returns:
    True if access is granted, or false otherwise.'''
        def checkPermissions_async(self, _cb, userId, password, _ctx=None):
            return _M_Glacier2.PermissionsVerifier._op_checkPermissions.invokeAsync(self, (_cb, (userId, password), _ctx))

        def checkedCast(proxy, facetOrCtx=None, _ctx=None):
            return _M_Glacier2.PermissionsVerifierPrx.ice_checkedCast(proxy, '::Glacier2::PermissionsVerifier', facetOrCtx, _ctx)
        checkedCast = staticmethod(checkedCast)

        def uncheckedCast(proxy, facet=None):
            return _M_Glacier2.PermissionsVerifierPrx.ice_uncheckedCast(proxy, facet)
        uncheckedCast = staticmethod(uncheckedCast)

    _M_Glacier2._t_PermissionsVerifierPrx = IcePy.defineProxy('::Glacier2::PermissionsVerifier', PermissionsVerifierPrx)

    _M_Glacier2._t_PermissionsVerifier = IcePy.defineClass('::Glacier2::PermissionsVerifier', PermissionsVerifier, (), True, None, (), ())
    PermissionsVerifier._ice_type = _M_Glacier2._t_PermissionsVerifier

    PermissionsVerifier._op_checkPermissions = IcePy.Operation('checkPermissions', Ice.OperationMode.Idempotent, Ice.OperationMode.Nonmutating, False, (), (((), IcePy._t_string), ((), IcePy._t_string)), (((), IcePy._t_string),), IcePy._t_bool, ())

    _M_Glacier2.PermissionsVerifier = PermissionsVerifier
    del PermissionsVerifier

    _M_Glacier2.PermissionsVerifierPrx = PermissionsVerifierPrx
    del PermissionsVerifierPrx

if not _M_Glacier2.__dict__.has_key('SSLPermissionsVerifier'):
    _M_Glacier2.SSLPermissionsVerifier = Ice.createTempClass()
    class SSLPermissionsVerifier(Ice.Object):
        '''The SSL Glacier2 permissions verifier. This is called through the
process of establishing a session.'''
        def __init__(self):
            if __builtin__.type(self) == _M_Glacier2.SSLPermissionsVerifier:
                raise RuntimeError('Glacier2.SSLPermissionsVerifier is an abstract class')

        def ice_ids(self, current=None):
            return ('::Glacier2::SSLPermissionsVerifier', '::Ice::Object')

        def ice_id(self, current=None):
            return '::Glacier2::SSLPermissionsVerifier'

        def ice_staticId():
            return '::Glacier2::SSLPermissionsVerifier'
        ice_staticId = staticmethod(ice_staticId)

        def authorize(self, info, current=None):
            '''Check whether a user has permission to access the router.

Arguments:
    info The SSL information.

    reason The reason why access was denied.

Returns:
    True if access is granted, or false otherwise.'''
            pass

        def __str__(self):
            return IcePy.stringify(self, _M_Glacier2._t_SSLPermissionsVerifier)

        __repr__ = __str__

    _M_Glacier2.SSLPermissionsVerifierPrx = Ice.createTempClass()
    class SSLPermissionsVerifierPrx(Ice.ObjectPrx):

        '''Check whether a user has permission to access the router.

Arguments:
    info The SSL information.

    reason The reason why access was denied.

Returns:
    True if access is granted, or false otherwise.'''
        def authorize(self, info, _ctx=None):
            return _M_Glacier2.SSLPermissionsVerifier._op_authorize.invoke(self, ((info, ), _ctx))

        '''Check whether a user has permission to access the router.

Arguments:
    info The SSL information.

    reason The reason why access was denied.

Returns:
    True if access is granted, or false otherwise.'''
        def begin_authorize(self, info, _response=None, _ex=None, _sent=None, _ctx=None):
            return _M_Glacier2.SSLPermissionsVerifier._op_authorize.begin(self, ((info, ), _response, _ex, _sent, _ctx))

        '''Check whether a user has permission to access the router.

Arguments:
    info The SSL information.

    reason The reason why access was denied.

Returns:
    True if access is granted, or false otherwise.'''
        def end_authorize(self, _r):
            return _M_Glacier2.SSLPermissionsVerifier._op_authorize.end(self, _r)

        '''Check whether a user has permission to access the router.

Arguments:
    info The SSL information.

    reason The reason why access was denied.

Returns:
    True if access is granted, or false otherwise.'''
        def authorize_async(self, _cb, info, _ctx=None):
            return _M_Glacier2.SSLPermissionsVerifier._op_authorize.invokeAsync(self, (_cb, (info, ), _ctx))

        def checkedCast(proxy, facetOrCtx=None, _ctx=None):
            return _M_Glacier2.SSLPermissionsVerifierPrx.ice_checkedCast(proxy, '::Glacier2::SSLPermissionsVerifier', facetOrCtx, _ctx)
        checkedCast = staticmethod(checkedCast)

        def uncheckedCast(proxy, facet=None):
            return _M_Glacier2.SSLPermissionsVerifierPrx.ice_uncheckedCast(proxy, facet)
        uncheckedCast = staticmethod(uncheckedCast)

    _M_Glacier2._t_SSLPermissionsVerifierPrx = IcePy.defineProxy('::Glacier2::SSLPermissionsVerifier', SSLPermissionsVerifierPrx)

    _M_Glacier2._t_SSLPermissionsVerifier = IcePy.defineClass('::Glacier2::SSLPermissionsVerifier', SSLPermissionsVerifier, (), True, None, (), ())
    SSLPermissionsVerifier._ice_type = _M_Glacier2._t_SSLPermissionsVerifier

    SSLPermissionsVerifier._op_authorize = IcePy.Operation('authorize', Ice.OperationMode.Idempotent, Ice.OperationMode.Nonmutating, False, (), (((), _M_Glacier2._t_SSLInfo),), (((), IcePy._t_string),), IcePy._t_bool, ())

    _M_Glacier2.SSLPermissionsVerifier = SSLPermissionsVerifier
    del SSLPermissionsVerifier

    _M_Glacier2.SSLPermissionsVerifierPrx = SSLPermissionsVerifierPrx
    del SSLPermissionsVerifierPrx

# End of module Glacier2

Ice.sliceChecksums["::Glacier2::PermissionsVerifier"] = "224cf229a378614459a5959f346c50"
Ice.sliceChecksums["::Glacier2::SSLPermissionsVerifier"] = "b796e7d91f35d3acbb5be98291aa9be4"
